Index: branches/UKMO/dev_isf_divg_corr_GO6_package_r9385/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/UKMO/dev_isf_divg_corr_GO6_package_r9385/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 9834)
+++ branches/UKMO/dev_isf_divg_corr_GO6_package_r9385/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 9835)
@@ -11,5 +11,5 @@
 ============================================================================================================
     -->
-   <field_definition level="1" prec="4" operation="average" enabled=".TRUE." default_value="1.e20" detect_missing_value="false"> <!-- time step automaticaly defined -->
+   <field_definition level="1" prec="4" operation="average" enabled=".TRUE." default_value="1.e20" detect_missing_value="true"> <!-- time step automaticaly defined -->
 
     <!-- 
Index: branches/UKMO/dev_isf_divg_corr_GO6_package_r9385/NEMOGCM/NEMO/OPA_SRC/DOM/iscplrst.F90
===================================================================
--- branches/UKMO/dev_isf_divg_corr_GO6_package_r9385/NEMOGCM/NEMO/OPA_SRC/DOM/iscplrst.F90	(revision 9834)
+++ branches/UKMO/dev_isf_divg_corr_GO6_package_r9385/NEMOGCM/NEMO/OPA_SRC/DOM/iscplrst.F90	(revision 9835)
@@ -24,5 +24,4 @@
    USE lbclnk          ! communication
    USE iscplini        ! ice sheet coupling: initialisation
-   !USE iscplhsb        ! ice sheet coupling: conservation
    USE iscpldiv
 
@@ -132,15 +131,14 @@
       !!
       INTEGER :: ji, jj, jk, iz          !! loop index
-      INTEGER :: jip1, jim1, jjp1, jjm1, jkp1, jkm1, jtop
+      INTEGER :: jip1, jim1, jjp1, jjm1, jkp1, jkm1
       !!
-      REAL(wp):: summsk, zsum, zsum1, zarea, zsumn, zsumb, zhdivdiff, zfp_ui, zfm_ui, zfp_vi, zfm_vi
-      REAL(wp):: zdz, zdzm1, zdzp1, zvol, zuflux_sum, zvflux_sum
-      REAL(wp),DIMENSION(2)::ztrdtsb
+      REAL(wp):: summsk, zsum, zsum1, zarea, zsumn, zsumb
+      REAL(wp):: zdz, zdzm1, zdzp1
       !!
-      REAL(wp), DIMENSION(:,:    ), POINTER :: zdmask , zdsmask, zvcorr, zucorr, zde3t
+      REAL(wp), DIMENSION(:,:    ), POINTER :: zdmask , zdsmask, zde3t
       REAL(wp), DIMENSION(:,:    ), POINTER :: zbub   , zbvb   , zbun  , zbvn
       REAL(wp), DIMENSION(:,:    ), POINTER :: zssh0  , zssh1, zhu1, zhv1
-      REAL(wp), DIMENSION(:,:    ), POINTER :: zsmask0, zsmask1, isfmask
-      REAL(wp), DIMENSION(:,:,:  ), POINTER :: ztmask0, ztmask1, ztrp, zuflux, zvflux, zhdiv, zhdiv2
+      REAL(wp), DIMENSION(:,:    ), POINTER :: zsmask0, zsmask1
+      REAL(wp), DIMENSION(:,:,:  ), POINTER :: ztmask0, ztmask1, ztrp
       REAL(wp), DIMENSION(:,:,:  ), POINTER :: zwmaskn, zwmaskb, ztmp3d
       REAL(wp), DIMENSION(:,:,:,:), POINTER :: zts0
@@ -150,7 +148,7 @@
       CALL wrk_alloc(jpi,jpj,jpk,2, zts0                                   )
       CALL wrk_alloc(jpi,jpj,jpk,   ztmask0, ztmask1 , ztrp, ztmp3d        ) 
-      CALL wrk_alloc(jpi,jpj,jpk,   zwmaskn, zwmaskb, zuflux, zvflux, zhdiv, zhdiv2               ) 
-      CALL wrk_alloc(jpi,jpj,       zsmask0, zsmask1, isfmask                       ) 
-      CALL wrk_alloc(jpi,jpj,       zdmask , zdsmask, zvcorr, zucorr, zde3t) 
+      CALL wrk_alloc(jpi,jpj,jpk,   zwmaskn, zwmaskb                       ) 
+      CALL wrk_alloc(jpi,jpj,       zsmask0, zsmask1                       ) 
+      CALL wrk_alloc(jpi,jpj,       zdmask , zdsmask, zde3t                ) 
       CALL wrk_alloc(jpi,jpj,       zbub   , zbvb    , zbun , zbvn         ) 
       CALL wrk_alloc(jpi,jpj,       zssh0  , zssh1, zhu1, zhv1             ) 
@@ -369,7 +367,7 @@
       CALL wrk_dealloc(jpi,jpj,jpk,2, zts0                                   )
       CALL wrk_dealloc(jpi,jpj,jpk,   ztmask0, ztmask1 , ztrp                ) 
-      CALL wrk_dealloc(jpi,jpj,jpk,   zwmaskn, zwmaskb , ztmp3d, zuflux, zvflux, zhdiv, zhdiv2    ) 
-      CALL wrk_dealloc(jpi,jpj,       zsmask0, zsmask1, isfmask                     ) 
-      CALL wrk_dealloc(jpi,jpj,       zdmask , zdsmask, zvcorr, zucorr, zde3t) 
+      CALL wrk_dealloc(jpi,jpj,jpk,   zwmaskn, zwmaskb , ztmp3d              ) 
+      CALL wrk_dealloc(jpi,jpj,       zsmask0, zsmask1                       ) 
+      CALL wrk_dealloc(jpi,jpj,       zdmask , zdsmask, zde3t                ) 
       CALL wrk_dealloc(jpi,jpj,       zbub   , zbvb    , zbun  , zbvn        ) 
       CALL wrk_dealloc(jpi,jpj,       zssh0  , zssh1  , zhu1 , zhv1          ) 