Index: NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/tests/BENCH/EXPREF/sh_bench
===================================================================
--- NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/tests/BENCH/EXPREF/sh_bench	(revision 9850)
+++ NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/tests/BENCH/EXPREF/sh_bench	(revision 9851)
@@ -1,12 +1,14 @@
 #!/bin/bash
 set -u
-set -xv
+#set -xv
 
-resolution=$1
+resolution=${1:?"you must provide the resolution: 1 025 or 12"}
+
 machine=$( hostname | sed -e "s/[0-9]*//g" )
 
 case $machine in 
     "beaufixlogin") ncore_node=40 ;;
-    "curie")   ncore_node=16 ;;
+    "curie")        ncore_node=16 ;;
+    "irene")        ncore_node=48 ;;
 esac
 
@@ -14,38 +16,33 @@
     16)
     case ${resolution} in
-	"1")list1="4*4 8*4 8*8 8*16 24*10 24*22 40*24 72*28 120*30 72*66" ;;
-	"025")list025="8*4 8*8 16*8 20*12 24*22 32*32 48*42 160*25 56*134 120*134 240*121" ;;
-	"12")list12="16*8 16*16 32*16 40*26 80*26 80*51 114*72 160*102 240*126" ;;
+	"1")  list="4*4 8*4 8*8 8*16 24*10 24*22 40*24 72*28 120*30 72*66" ;;
+	"025")list="8*4 8*8 16*8 20*12 24*22 32*32 48*42 160*25 56*134 120*134 240*121" ;;
+	"12") list="16*16 32*16 40*26 80*26 80*51 114*72 160*102 240*126" ;;
     esac
     ;;
     40)
     case ${resolution} in
-	"1")list1="8*5 8*10 16*10 20*16 20*30 40*33 60*42 120*42" ;;
-	"025")list025="8*5 10*8 16*10 20*16 20*32 40*32 60*42 80*67 180*64" ;;
-	"12")list12="40*31 60*42 80*63 160*75" ;;
+	"1")  list="8*5 8*10 10*16 20*16 20*30 40*33 60*42 120*42" ;;
+	"025")list="8*5 10*8 16*10 20*16 20*32 40*32 60*42 80*67 180*64" ;;
+	"12") list="40*31 60*42 80*63 160*75" ;;
+    esac
+    ;;
+    48)
+    case ${resolution} in
+	"1")  list="8*6 12*8 19*10 24*16 24*30 45*33 72*42" ;;
+	"025")list="8*6 12*8 16*12 24*16 24*32 48*32 48*64 96*64 480*25 144*173 720*39" ;;
+	"12") list="12*16 24*16 48*16 48*32 80*39 96*63 144*85 160*150 240*126" ;;
     esac
     ;;
 esac
 
-
-# ORCA1
-if [ ${resolution} == "1" ]; then
-for cores in $list1
+for ii in $list
 do
-  ./submit_bench $cores $ncore_node ${resolution}
+    echo "$ii = $ncore_node * $( echo "scale=3 ; $ii/${ncore_node}" | bc ) = $( echo $ii | bc )"
 done
 
-# ORCA025
-elif [ ${resolution} == "025" ]; then
-for cores in $list025
+for cores in $list
 do
-  ./submit_bench $cores $ncore_node ${resolution}
+    ./submit_bench $cores $ncore_node ${resolution}
 done
 
-# ORCA12
-elif [ ${resolution} == "12" ]; then
-for cores in $list12
-do
-  ./submit_bench $cores $ncore_node ${resolution}
-done
-fi
Index: NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/tests/BENCH/EXPREF/submit_bench
===================================================================
--- NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/tests/BENCH/EXPREF/submit_bench	(revision 9850)
+++ NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/tests/BENCH/EXPREF/submit_bench	(revision 9851)
@@ -12,5 +12,4 @@
 resolution=$3
 machine=$( hostname | sed -e "s/[0-9]*//g" )
-######################################################################
 #
 # number of processes for each executable
@@ -21,4 +20,8 @@
 
 nproc5=$( printf "%05d\n" ${nproc_exe1} )
+
+######################################################################
+### beaufixlogin
+######################################################################
 
 if [ "$machine" == "beaufixlogin" ]
@@ -79,6 +82,4 @@
 
 
-######################################################################
-###
 ### 4. Execute the model
 
@@ -89,11 +90,14 @@
 echo 'is executed or submitted to queue.'
 
-######################################################################
 
 fi
 
-if [ "$machine" == "curie" ]
+######################################################################
+### curie or irene
+######################################################################
+
+if [[ ( "$machine" == "curie" ) || ( "$machine" == "irene" ) ]]
 then
-
+    
     case ${resolution} in
 	"1")
@@ -101,8 +105,14 @@
 	    then
 		timejob=3600
+	    elif [ $nproc_exe1 -lt 100 ]
+	    then
+		timejob=1800
+	    elif [ $nproc_exe1 -lt 200 ]
+	    then
+		timejob=900
 	    else
-		timejob=1800
+		timejob=600
 	    fi
-	;;
+	    ;;
 	"025")
 	    if [ $nproc_exe1 -lt 50 ]
@@ -115,18 +125,24 @@
 	    then
 		timejob=3600
+	    elif [ $nproc_exe1 -lt 400 ]
+	    then
+		timejob=2000
+	    elif [ $nproc_exe1 -lt 800 ]
+	    then
+		timejob=1000
 	    else
-		timejob=1800
+		timejob=600
 	    fi
-	;;
+	    ;;
 	"12")
 	    if [ $nproc_exe1 -lt 200 ]
 	    then
-		timejob=36000
+		timejob=30000
 	    elif [ $nproc_exe1 -lt 400 ]
 	    then
-		timejob=20000
+		timejob=15000
 	    elif [ $nproc_exe1 -lt 800 ]
 	    then
-		timejob=10000
+		timejob=8000
 	    elif [ $nproc_exe1 -lt 1600 ]
 	    then
@@ -134,16 +150,17 @@
 	    elif [ $nproc_exe1 -lt 3200 ]
 	    then
-		timejob=3600
+		timejob=2500
 	    else
-		timejob=1800
+		timejob=1200
 	    fi
 	;;
     esac
 
-   
+    [ "$machine" == "curie" ] && queuename=standard || queuename=skylake
+    
     jobname=$HOME/binrun/jobbench
     cat > $jobname << EOF
 #!/bin/bash
-#MSUB -r jobbench${nproc5}
+#MSUB -r bench${nproc5}
 #MSUB -n ${nproc_exe1}
 #MSUB -T $timejob
@@ -152,5 +169,5 @@
 #MSUB -j oe
 #MSUB -x
-#MSUB -q standard
+#MSUB -q ${queuename}
 #MSUB -A gen6895
 #==========================================