Index: NEMO/trunk/src/ICE/icestp.F90
===================================================================
--- NEMO/trunk/src/ICE/icestp.F90	(revision 9871)
+++ NEMO/trunk/src/ICE/icestp.F90	(revision 9872)
@@ -137,6 +137,6 @@
          !                          !==  AGRIF Parent to Child  ==!
 #if defined key_agrif
-         !                              ! lim_nbstep ranges from 1 to the nb of child ocean steps inside one parent ice step
-         IF( .NOT. Agrif_Root() )       lim_nbstep = MOD( lim_nbstep, Agrif_irhot() * Agrif_Parent(nn_fsbc) / nn_fsbc ) + 1
+         !                              ! nbstep_ice ranges from 1 to the nb of child ocean steps inside one parent ice step
+         IF( .NOT. Agrif_Root() )       nbstep_ice = MOD( nbstep_ice, Agrif_irhot() * Agrif_Parent(nn_fsbc) / nn_fsbc ) + 1
          !                              ! these calls must remain here for restartability purposes
                                         CALL agrif_interp_ice( 'T' ) 
Index: NEMO/trunk/src/NST/agrif_ice.F90
===================================================================
--- NEMO/trunk/src/NST/agrif_ice.F90	(revision 9871)
+++ NEMO/trunk/src/NST/agrif_ice.F90	(revision 9872)
@@ -16,5 +16,5 @@
 
    INTEGER, PUBLIC ::  u_ice_id, v_ice_id, tra_ice_id
-   INTEGER, PUBLIC ::  lim_nbstep = 0    ! child time position in sea-ice model
+   INTEGER, PUBLIC ::  nbstep_ice = 0    ! child time position in sea-ice model
 
    !!----------------------------------------------------------------------
Index: NEMO/trunk/src/NST/agrif_ice_interp.F90
===================================================================
--- NEMO/trunk/src/NST/agrif_ice_interp.F90	(revision 9871)
+++ NEMO/trunk/src/NST/agrif_ice_interp.F90	(revision 9872)
@@ -57,11 +57,11 @@
       CASE('U','V')
          IF( PRESENT( kiter ) ) THEN  ! interpolation at the child ice sub-time step (only for ice rheology)
-            zbeta = ( REAL(lim_nbstep) - REAL(kitermax - kiter) / REAL(kitermax) ) /  &
+            zbeta = ( REAL(nbstep_ice) - REAL(kitermax - kiter) / REAL(kitermax) ) /  &
                &    ( Agrif_Rhot() * REAL(Agrif_Parent(nn_fsbc)) / REAL(nn_fsbc) )
          ELSE                         ! interpolation at the child ice time step
-            zbeta = REAL(lim_nbstep) / ( Agrif_Rhot() * REAL(Agrif_Parent(nn_fsbc)) / REAL(nn_fsbc) )
+            zbeta = REAL(nbstep_ice) / ( Agrif_Rhot() * REAL(Agrif_Parent(nn_fsbc)) / REAL(nn_fsbc) )
          ENDIF
       CASE('T')
-            zbeta = REAL(lim_nbstep) / ( Agrif_Rhot() * REAL(Agrif_Parent(nn_fsbc)) / REAL(nn_fsbc) )
+            zbeta = REAL(nbstep_ice) / ( Agrif_Rhot() * REAL(Agrif_Parent(nn_fsbc)) / REAL(nn_fsbc) )
       END SELECT
       !
Index: NEMO/trunk/src/NST/agrif_user.F90
===================================================================
--- NEMO/trunk/src/NST/agrif_user.F90	(revision 9871)
+++ NEMO/trunk/src/NST/agrif_user.F90	(revision 9872)
@@ -483,11 +483,11 @@
       CALL ctl_stop('rhot * nn_fsbc(parent) /= N * nn_fsbc(child), therefore nn_fsbc(child) should be set to 1 or nn_fsbc(parent)')
    ENDIF
-   ! First Interpolations (using "after" ice subtime step => lim_nbstep=1)
+   ! First Interpolations (using "after" ice subtime step => nbstep_ice=1)
    !----------------------------------------------------------------------
-   lim_nbstep = ( Agrif_irhot() * Agrif_Parent(nn_fsbc) / nn_fsbc ) ! clem: to have calledweight=1 in interp (otherwise the western border of the zoom is wrong)
+   nbstep_ice = ( Agrif_irhot() * Agrif_Parent(nn_fsbc) / nn_fsbc ) ! clem: to have calledweight=1 in interp (otherwise the western border of the zoom is wrong)
    CALL agrif_interp_ice('U') ! interpolation of ice velocities
    CALL agrif_interp_ice('V') ! interpolation of ice velocities
    CALL agrif_interp_ice('T') ! interpolation of ice tracers 
-   lim_nbstep = 0
+   nbstep_ice = 0
    
    !
Index: NEMO/trunk/src/OCE/SBC/sbccpl.F90
===================================================================
--- NEMO/trunk/src/OCE/SBC/sbccpl.F90	(revision 9871)
+++ NEMO/trunk/src/OCE/SBC/sbccpl.F90	(revision 9872)
@@ -1352,5 +1352,5 @@
       IF( srcv(jpr_ocx1)%laction ) THEN                      ! received by sas in case of opa <-> sas coupling
          ssu_m(:,:) = frcv(jpr_ocx1)%z3(:,:,1)
-         ub (:,:,1) = ssu_m(:,:)                             ! will be used in icestp in the call of lim_sbc_tau
+         ub (:,:,1) = ssu_m(:,:)                             ! will be used in icestp in the call of ice_forcing_tau
          un (:,:,1) = ssu_m(:,:)                             ! will be used in sbc_cpl_snd if atmosphere coupling
          CALL iom_put( 'ssu_m', ssu_m )
@@ -1358,5 +1358,5 @@
       IF( srcv(jpr_ocy1)%laction ) THEN
          ssv_m(:,:) = frcv(jpr_ocy1)%z3(:,:,1)
-         vb (:,:,1) = ssv_m(:,:)                             ! will be used in icestp in the call of lim_sbc_tau
+         vb (:,:,1) = ssv_m(:,:)                             ! will be used in icestp in the call of ice_forcing_tau
          vn (:,:,1) = ssv_m(:,:)                             ! will be used in sbc_cpl_snd if atmosphere coupling
          CALL iom_put( 'ssv_m', ssv_m )