Index: /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/iceistate.F90
===================================================================
--- /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/iceistate.F90	(revision 9880)
+++ /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/iceistate.F90	(revision 9881)
@@ -21,5 +21,5 @@
    USE dom_oce        ! ocean domain
    USE sbc_oce , ONLY : sst_m, sss_m, ln_ice_embd 
-   USE sbc_ice , ONLY : tn_ice, snwice_mass, snwice_mass_b
+   USE sbc_ice , ONLY : snwice_mass, snwice_mass_b
    USE eosbn2         ! equation of state
    USE domvvl         ! Variable volume
@@ -353,5 +353,4 @@
          END DO
          !
-         tn_ice (:,:,:) = t_su (:,:,:)
          t1_ice (:,:,:) = t_i (:,:,1,:)   ! initialisation of 1st layer temp for coupled simu
 
@@ -390,5 +389,4 @@
          END DO
 
-         tn_ice (:,:,:) = t_i (:,:,1,:)
          t1_ice (:,:,:) = t_i (:,:,1,:)   ! initialisation of 1st layer temp for coupled simu
          
Index: /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90
===================================================================
--- /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90	(revision 9880)
+++ /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90	(revision 9881)
@@ -257,5 +257,5 @@
       !
       fr_i  (:,:)   = at_i(:,:)        ! initialisation of sea-ice fraction
-      tn_ice(:,:,:) = t_su(:,:,:)      ! initialisation of surface temp for coupled simu
+      t1_ice(:,:,:) = t_su(:,:,:)      ! initialisation of surface temp for coupled simu
       !
       !                                ! set max concentration in both hemispheres
Index: /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90
===================================================================
--- /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 9880)
+++ /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 9881)
@@ -89,5 +89,5 @@
       !!              - sfx     : salt flux 
       !!              - fr_i    : ice fraction
-      !!              - tn_ice  : sea-ice surface temperature
+      !!              - t1_ice  : sea-ice surface temperature
       !!              - alb_ice : sea-ice albedo (recomputed only for coupled mode)
       !!
@@ -190,5 +190,5 @@
       !----------------------------------
       fr_i  (:,:)   = at_i(:,:)             ! Sea-ice fraction            
-      tn_ice(:,:,:) = t_su(:,:,:)           ! Ice surface temperature                      
+      t1_ice(:,:,:) = t_su(:,:,:)           ! Ice surface temperature                      
 
       ! Snow/ice albedo (only if sent to coupler, useless in forced mode)
Index: /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90
===================================================================
--- /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 9880)
+++ /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 9881)
@@ -50,6 +50,9 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zevap_ice        !: latent flux over ice                          [W/m2]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dqla_ice       !: latent sensibility over ice                 [W/m2/K]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qla_ice        !:  latent heat flux over ice                  [W/m2/K]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dqns_ice       !: non solar heat flux over ice (LW+SEN+LA)    [W/m2/K]
+#if ! defined  key_lim3
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   t1_ice         !: ice surface temperature                          [K]
+# endif
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   alb_ice        !: ice albedo                                       [-]
 
@@ -194,5 +197,9 @@
    INTEGER         , PUBLIC, PARAMETER ::   jpl = 1 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   u_ice, v_ice                        ! jpi, jpj
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   t1_ice, alb_ice, qns_ice, dqns_ice  ! (jpi,jpj,jpl)
+#if ! defined  key_lim3
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   t1_ice
+#endif
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   alb_ice, qns_ice, dqns_ice  ! (jpi,jpj,jpl)
+
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   a_i
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   emp_ice
Index: /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk.F90
===================================================================
--- /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk.F90	(revision 9880)
+++ /branches/UKMO/dev_merge_2017_CICE_interface_SI3_JGLR/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk.F90	(revision 9881)
@@ -40,5 +40,4 @@
    USE fldread        ! read input fields
    USE sbc_oce        ! Surface boundary condition: ocean fields
-   USE cyclone        ! Cyclone 10m wind form trac of cyclone centres
    USE sbcdcy         ! surface boundary condition: diurnal cycle
    USE sbcwave , ONLY :   cdn_wave ! wave module